HDU-5441 Travel 离线-并查集
Posted mengx
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了HDU-5441 Travel 离线-并查集相关的知识,希望对你有一定的参考价值。
Travel
Time Limit: 1500/1000 MS (Java/Others) Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 4680 Accepted Submission(s): 1532
Problem Description
Jack likes to travel around the world, but he doesn’t like to wait. Now, he is traveling in the Undirected Kingdom. There are n cities and m bidirectional roads connecting the cities. Jack hates waiting too long on the bus, but he can rest at every city. Jack can only stand staying on the bus for a limited time and will go berserk after that. Assuming you know the time it takes to go from one city to another and that the time Jack can stand staying on a bus is x minutes, how many pairs of city (a,b) are there that Jack can travel from city a to b without going berserk?
Input
The first line contains one integer T,T≤5, which represents the number of test case.
For each test case, the first line consists of three integers n,m and q where n≤20000,m≤100000,q≤5000. The Undirected Kingdom has n cities and mbidirectional roads, and there are q queries.
Each of the following m lines consists of three integers a,b and d where a,b∈{1,...,n} and d≤100000. It takes Jack d minutes to travel from city a to city b and vice versa.
Then q lines follow. Each of them is a query consisting of an integer x where x is the time limit before Jack goes berserk.
For each test case, the first line consists of three integers n,m and q where n≤20000,m≤100000,q≤5000. The Undirected Kingdom has n cities and mbidirectional roads, and there are q queries.
Each of the following m lines consists of three integers a,b and d where a,b∈{1,...,n} and d≤100000. It takes Jack d minutes to travel from city a to city b and vice versa.
Then q lines follow. Each of them is a query consisting of an integer x where x is the time limit before Jack goes berserk.
Output
You should print q lines for each test case. Each of them contains one integer as the number of pair of cities (a,b) which Jack may travel from a to b within the time limit x.
Note that (a,b) and (b,a) are counted as different pairs and a and b must be different cities.
Note that (a,b) and (b,a) are counted as different pairs and a and b must be different cities.
Sample Input
1
5 5 3
2 3 6334
1 5 15724
3 5 5705
4 3 12382
1 3 21726
6000
10000
13000
Sample Output
2
6
12
Source
Recommend
题意:t组数据,每次n个点,m条边,q次询问,每次给出一个值,求用到所有边权不大于这个值的边的情况下,能够互相到达的点对的个数
思路:离线并查集,按权值排序即可
#include<bits/stdc++.h> #define lson l,m,rt<<1 #define rson m+1,r,rt<<1|1 #define ll long long #define mem(a,b) memset(a,b,sizeof(a)) using namespace std; const int maxn = 20005; int pre[maxn],r[maxn]; ll ans[maxn]; struct node { int u,v; ll val; bool friend operator < (const node xx,const node yy) { return xx.val<yy.val; } } e[maxn*10]; struct pp { ll dis; int id; bool friend operator < (const pp xx,const pp yy) { return xx.dis<yy.dis; } } Q[5005]; void init(int n) { for(int i=1; i<=n; i++) {pre[i]=i;r[i]=1;} } int Find(int x) { return x==pre[x]?x:pre[x]=Find(pre[x]); } int main() { int t,n,m,q; scanf("%d",&t); while(t--) { scanf("%d %d %d",&n,&m,&q); init(n); for(int i=1; i<=m; i++) { scanf("%d %d %lld",&e[i].u,&e[i].v,&e[i].val); } sort(e+1,e+1+m); for(int i=1; i<=q; i++) { scanf("%lld",&Q[i].dis); Q[i].id=i; } sort(Q+1,Q+1+q); int j=1,cnt=0; for(int i=1; i<=q; i++) { while(j<=m&&Q[i].dis>=e[j].val) { int u=Find(e[j].u); int v=Find(e[j].v); if(u!=v) { cnt+=r[u]*r[v]; pre[u]=v; r[v]+=r[u]; } j++; } ans[Q[i].id]=cnt<<1; } for(int i=1;i<=q;i++) printf("%lld ",ans[i]); } }
PS:摸鱼怪的博客分享,欢迎感谢各路大牛的指点~
以上是关于HDU-5441 Travel 离线-并查集的主要内容,如果未能解决你的问题,请参考以下文章
Travel(HDU 5441 2015长春区域赛 带权并查集)
2015 ACM/ICPC Asia Regional Changchun Online HDU - 5441 (离线+并查集)